
/**range [0,1) */
function urandom()
{return Math.random()}
/**uniform distribution [-scale,scale)*/
function uni(scale=1)
{return (urandom()-0.5)*2*scale}
/** 
 * @template T
 * @param {T[]} arr
 * @returns {T}
 * */
function choose(arr=[])
{return arr[parseInt(urandom()*arr.length)]}
/** 
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 * */
function argmin(arr=[],key=parseInt)
{
    var k=arr.map(x=>key(x)).map(x=>isNaN(x)?Infinity:x)
    var kmin=Math.min(...(k.flat()))
    return k.findIndex(x=>x==kmin)
}
/**
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 */
function min(arr=[],key=parseInt)
{return arr[argmin(arr,key)]}
/**
 * @template T
 * @param {T[]} arr1
 * @param {T[]} arr2
 * @param {(a:T,b:T)=>Number} key
 * @returns {T[][]}
 */
function pair(arr1=[],arr2=[],key=(a,b)=>Math.abs(a-b))
{
    var arr1=Array.from(arr1).reverse()
    var arr2=Array.from(arr2)
    var out=[]
    while (arr1.length>0 && arr2.length>0)
    {
        var a=arr1.pop()
        var bi=argmin(arr2,(b)=>key(a,b))
        var b=arr2.splice(bi,1)[0]
        out.push([a,b])
    }
    return out
}







const _core=[
    "A0CommandCentre","A0PowerGenerator","A0ResearchFacility",
    "A0LightFactory","A0VTolFactory1","A0CyborgFactory",
    "A0RepairCentre3","A0VtolPad",
    "A0Sat-linkCentre","A0LasSatCommand"]
const _coreMod={
    "Research Facility":["A0ResearchModule1",1],
    "Power Generator":["A0PowMod1",1],
    "Factory":["A0FacMod1",2],
    "VTOL Factory":["A0FacMod1",2],
}
const _defense=["X-Super-MassDriver","X-Super-Cannon","Tower-Projector","PillBox5","A0HardcreteMk1Wall"]
const _sensor=["Sys-SensoTowerWS","Sys-SensoTower02","A0HardcreteMk1Wall"]
const _artillery=["Emplacement-Howitzer150","Emplacement-Howitzer105","Emplacement-MortarPit02","Emplacement-MortarPit01","A0HardcreteMk1Wall"]
const _cyborgBaseL=["CyborgLightBody",'CyborgLegs',0,0] 
const _cyborgBaseH=["CyborgHeavyBody",'CyborgLegs',0,0]
const _droidBase=[
    ["Body14SUP","Body13SUP","Body10MBT","Body9REC","Body12SUP","Body11ABT","Body6SUPP","Body8MBT","Body5REC","Body3MBT","Body2SUP","Body4ABT","Body1REC"],
    ["tracked01",'HalfTrack','wheeled01'],0,0]
const _vtolBase=[
    ["Body14SUP","Body13SUP","Body10MBT","Body9REC","Body12SUP","Body11ABT","Body6SUPP","Body8MBT","Body5REC","Body3MBT","Body2SUP","Body4ABT","Body1REC"],
    ["V-Tol"],0,0]

const _droidCannon=["RailGun3Mk1","RailGun2Mk1",'RailGun1Mk1',"Cannon6TwinAslt",'Cannon375mmMk1',"Cannon5VulcanMk1","Cannon2A-TMk1","MG2Mk1","MG1Mk1"]
const _droidFlame=["Laser4-PlasmaCannon","Flame2","Flame1Mk1","MG1Mk1"]
const _droidMg=["MG5TWINROTARY","MG4ROTARYMk1","MG3Mk1","MG2Mk1","MG1Mk1"]
const _droidAA=["Missile-HvySAM","Missile-LtSAM","AAGunLaser","QuadRotAAGun","AAGun2Mk1Quad","QuadMg1AAGun","Rocket-Sunburst","AAGun2Mk1"]
const _droidBomb=["Bomb5-VTOL-Plasmite","Bomb4-VTOL-HvyINC","Bomb2-VTOL-HvHE","Bomb1-VTOL-LtHE"]







/** 
 * @param {_object} a
 * @param {_object} b
*/
function byBorn(a,b)
{return (a.born+a.id/10000000)-(b.born+b.id/10000000)}


function isDamaged(droid)
{return goodCount("A0RepairCentre3")>0 && droid.health<(50*(1.5-goodCount()))}
function isFree(droid)
{
    if (droid===undefined)return false
    return !isDamaged(droid) && droid.order!=DORDER_RECYCLE && droid.order!=DORDER_RTR
}
function isJammed(droid)
{return enumRange(droid.x,droid.y,2).filter(x=>x.type==DROID).length>3}

function distBetween(object,object2)
{
    if (object===undefined || object2===undefined)return Infinity
    return distBetweenTwoPoints(object.x,object.y,object2.x,object2.y)
}
/** for sorting */
function distTo(object)
{return (object2)=>distBetween(object,object2)}

function enumOil()
{return enumFeature(ALL_PLAYERS).filter((x)=>(x.stattype === OIL_RESOURCE))}
/** 
 * @returns {String[]}
*/
function enumStat(x=Stats.Building)
{return Object.keys(x).map(i=>x[i].Id)}

function enumEnemy()
{
    return startPositions.map((x,i)=>i).filter(i=>allianceExistsBetween(me,i))
}








include("/multiplay/skirmish/dumb_good.js")
function freeCell(droid)
{
    var home=startPositions[me]
    return pickStructLocation(droid,"A0PowerGenerator",home.x,home.y)
}
function monoAttack(droid,target)
{
    if (target===undefined | target===null)return
    return spamMove(droid,8,target)
}
function fullAttack(target)
{
    var full=enumDroid(me).filter(droid=>droid.droidType==DROID_CYBORG || droid.droidType==DROID_WEAPON).filter(isFree)
    var full2=enumDroid(target.player)
    var gc=goodCount()
    var home=startPositions[me]
    //if (target.type===STRUCTURE)full=full.filter(droid=>urandom()<0.1)
    full.forEach((droid)=>{
        if (distBetween(droid,home)<(28+droid.range/128) || (gc>0.8) || (full.length>full2.length*2))
        {
            if (isVTOL(droid))return orderDroidObj(droid,DORDER_ATTACK,target)
            return spamMove(droid,5,target)
        }
        else 
        {
            if (isVTOL(droid))
            {
                if (distBetween(target,home)>40)return orderDroid(droid,DORDER_REARM)
                else return orderDroidObj(droid,DORDER_ATTACK,target)
            }

            if (distBetween(droid,home)>36)return spamMove(droid,5,home)
            else return spamMove(droid,5,droid)
        }
    })
}

function monoResearch(lab)
{
    var research=enumResearch()
    if (research.length==0)return
    pursueResearch(lab,min(research,x=>goodResearch(x.id)).id)
}

function monoFactory(factory)
{
    var w=_droidCannon
    if (!componentAvailable(undefined,'RailGun1Mk1') && !componentAvailable(undefined,"Cannon375mmMk1")) if (urandom()<0.3){var w=choose([_droidFlame,_droidMg,_droidMg])}
    if (componentAvailable(undefined,"V-Tol")) if (urandom()<0.3) {var w=[..._droidAA,..._droidCannon]}
    
    var w2=["RailGun3Mk1","RailGun2Mk1",'RailGun1Mk1']
    if (enumDroid(me,DROID_SENSOR).length<3 && goodCount()>0.4)w="SensorTurret1Mk1"
    if (enumDroid(me,DROID_CONSTRUCT).length<8)w="Spade1Mk1"
    buildDroid(factory,"tank",..._droidBase,w,w2)
}
function monoFactory2(factoryCyborg)
{
    var w=["Cyb-Hvywpn-RailGunner","Cyb-Wpn-Rail1","Cyb-Hvywpn-Mcannon","CyborgCannon","CyborgChaingun"].find(x=>componentAvailable(undefined,x))
    if (!componentAvailable("Cyb-Wpn-Rail1") && urandom()<0.3)w=["Cyb-Wpn-Thermite","CyborgFlamer01"].find(x=>componentAvailable(undefined,x))
    if (countDroid(DROID_CONSTRUCT,me)<5)w="CyborgSpade"
    if (w==undefined)return
    var base=_cyborgBaseL
    if (w.includes("Hvywpn"))base=_cyborgBaseH
    return buildDroid(factoryCyborg,"cyborg",...base,w)
}
function monoFactory3(factoryVtol)
{
    var w=_droidBomb
    if (!_droidBomb.find(x=>componentAvailable(undefined,x)))return
    buildDroid(factoryVtol,"vtol",..._vtolBase,w)
}









/** build as a larger building will preserve more space */
function spamBuild(truck,struct="A0PowerGenerator",near,as)
{
    if (near===undefined)near=truck
    if (as===undefined)as=struct
    var pos=pickStructLocation(truck,as,near.x,near.y)
    if (struct=="A0ResourceExtractor")pos=near
    if (pos===undefined)return
    return orderDroidBuild(truck, DORDER_BUILD, struct, pos.x,pos.y)
}

function spamMove(droid,scale=5,near)
{
    if (near===undefined)near=droid
    try{orderDroidLoc(droid,DORDER_MOVE,near.x+uni(scale),near.y+uni(scale))}
    catch{}
}










function zStruct()
{
    var lab=enumStruct(me,RESEARCH_LAB)
    var cyborg_factory=enumStruct(me,CYBORG_FACTORY)
    var factory=enumStruct(me,FACTORY)
    var vtol_factory=enumStruct(me,VTOL_FACTORY)
    var lassat=enumStruct(me,LASSAT)
    var full2=enumDroid(choose(enumEnemy()))

    lassat.forEach((x)=>{activateStructure(x,choose(full2))})
    lab.filter(structureIdle).forEach(monoResearch)
    if (playerPower(me)>100)cyborg_factory.filter(structureIdle).forEach(monoFactory2)
    if (playerPower(me)>300)factory.filter(structureIdle).forEach(monoFactory)
    if (playerPower(me)>300 && urandom()<0.2)vtol_factory.filter(structureIdle).forEach(monoFactory3) 
}


function zDroid()
{   
    var droidTeam=enumDroid(me)//.filter(x=>urandom(x.id+gameTime)<0.2)
    var tobuildTeam=enumStruct(me).filter(x=>x.status==BEING_BUILT).filter(x=>x.stattype!=OIL_RESOURCE)
    var tomodTeam=enumStruct(me).filter(x=>_coreMod[x.name]!=undefined).filter(x=>isStructureAvailable(_coreMod[x.name][0],me) && x.modules<_coreMod[x.name][1])
    var truckTeam=droidTeam.filter(droid=>droid.droidType==DROID_CONSTRUCT).filter(truck=>truck.order!=DORDER_BUILD).sort(byBorn)
    var truckTeam2=truckTeam.splice(0,parseInt(truckTeam.length/3))
    var gc=goodCount()

    var weaponTeam=droidTeam.filter(droid=>droid.droidType!=DROID_CONSTRUCT)

    var truckLock={}
    if (goodCount("A0ResourceExtractor")<goodCount("A0PowerGenerator"))
    {
        var tos=pair(truckTeam2,enumOil(),distBetween)
        tos.forEach((x)=>{
            var [truck,oil]=x
            spamBuild(truck,"A0ResourceExtractor",oil)
        })
    }

    truckTeam.forEach((truck)=>{
        if (tobuildTeam.length>0)
        {
            var nearestTobuild=min(tobuildTeam,distTo(truck))
            if (distBetween(truck,nearestTobuild)<8)return orderDroidObj(truck,DORDER_HELPBUILD,nearestTobuild)
        }

        var core=min(_core.filter((x)=>isStructureAvailable(x,me)),goodCore)
        if (!!core && !truckLock[core])
        {
            truckLock[core]=true
            if (core!="A0VtolPad" || enumDroid(me).filter(isVTOL).length>(enumStruct(me,"A0VtolPad").length*2))
            return spamBuild(truck,core,min(enumStruct(me,core),x=>x.born))
        }

        if (tomodTeam.length>0)
        {
            var nearestTomod=min(tomodTeam,distTo(truck))
            if (distBetween(truck,nearestTomod)<32)return orderDroidBuild(truck,DORDER_BUILD,_coreMod[nearestTomod.name][0],nearestTomod.x,nearestTomod.y)
        }

        if (playerPower(me)>5000)
        {
            var defense=_defense.find(x=>isStructureAvailable(x,me))
            var sensor=_sensor.find(x=>isStructureAvailable(x,me))  
            var artillery=_artillery.find(x=>isStructureAvailable(x,me))     
            var auxr=defense
            var as="A0LightFactory"
            if (urandom()<0.4)
            {
                auxr=artillery
                as="A0PowerGenerator"
                if (urandom()<0.2){auxr=sensor}
            }
            
            if (!!auxr && !truckLock[auxr])
            {
                truckLock[auxr]=true
                spamBuild(truck,auxr,truck,as)
            }
        }
    })

    weaponTeam.forEach((weapon)=>{
        if (urandom()<0.01 && (gameTime*2/3)>(weapon.born) && gc>0.95)
        {return orderDroid(weapon,DORDER_RECYCLE)}
        
        if (isVTOL(weapon))return

        if (isDamaged(weapon))
        {
            if (urandom()<0.3 && isJammed(weapon))return spamMove(weapon)
            else return orderDroid(weapon,DORDER_RTR)
        }
        if (urandom()<0.05 && isJammed(weapon))return spamMove(weapon) 
        if (urandom()<0.05)
        {
            var target=min(enumRange(weapon.x,weapon.y,20,ENEMIES),(x)=>goodTarget(x)+16*distBetween(x,weapon))
            if (!!target)fullAttack(target)
            else spamMove(weapon,20,startPositions[me])
        }

    })

    

}








function eventStartLevel() 
{
    setTimer("zStruct", 1009+me*3);
    setTimer("zDroid", 499+me*3); 
}
function eventAttacked(victim, attacker)
{
    if (allianceExistsBetween(me,attacker.player))return
    var sensorTeam=enumDroid(me,DROID_SENSOR)
    var sensor=min(sensorTeam,distTo(attacker))
    if (!!sensor)orderDroidObj(sensor,DORDER_OBSERVE,attacker)
    if (victim.type==DROID && !isVTOL(victim))orderDroid(victim,DORDER_RTB)
}

function eventChat(from, to, message)
{
    if (from==me && to==me)
    {
        if (message=="q")
        {
            console(`goodCount:${goodCount()}`)
            startPositions.forEach((pos,i)=>{
                var x=enumDroid(i)
                var x2=x.filter(droid=>droid.droidType==DROID_WEAPON)
                var y=enumStruct(i)
                console(`player:${i},pos:${JSON.stringify([pos.x,pos.y])},droid:${x.length}(${x2.length}),structure:${y.length},power:${playerPower(i)}`)
            })
        }
    }
}